#!/usr/bin/perl

my @zaparray = ();

my @channelstrings = [];

my $xmltvfile = "";

for ($i=0; $i<=$#ARGV; $i++){
  if ($ARGV[$i] eq "-x") {
    $i++;
    $xmltvfile = $ARGV[$i];
    }
  elsif ($ARGV[$i] eq "-c") {
    $i++;
    $chanidentsfile = $ARGV[$i];
    }
  elsif ($ARGV[$i] eq "-h" || $ARGV[$i] eq "-help" || $ARGV[$i] eq "--help" ) {
    print "Zap2Myth v0.1\n";
    print "Usage [OPTIONS]... [CHANNEL_FILES]...\n\n";
    print "  -h             This help\n";
    print "  -x XMLTVFILE   Dump xmltv channel list to file\n";
    print "  -c DVBGRABFILE Dump tv_grab_dvb channel conversion to file\n";
    
    exit;
    }
  else{
    open (CN, $ARGV[$i]);
    my @channelstrings = <CN>;
    close (CN);
    foreach $channelstring (@channelstrings){
        my @channelline = split(/:/, $channelstring);
        push @channelarray, [@channelline] ;
        }
    }
  }
if (!($xmltvfile eq "")){
  open (XF, "> $xmltvfile");
  }

if (!($chanidentsfile eq "")){
  open (CF, "> $chanidentsfile");
  }

open (ZAP, "< /root/.tzap/channels.conf");
my @zapstrings = <ZAP>;
close (ZAP);



print "USE mythconverg\;\n";
print "DELETE FROM channel where chanid < 2000\;\n";
print "DELETE FROM dvb_channel where chanid < 2000\;\n";
print "DELETE FROM dvb_pids where chanid < 2000\;\n";


foreach $zapstring (@zapstrings){
    my @zapline = split(/:/, $zapstring);
    push @zaparray , [ @zapline] ;
    }

foreach $zapline (@zaparray){
  foreach $channel (@channelarray){
    if (@$zapline[0] eq @$channel[0]){



      @$zapline[3] =~ sBANDWIDTH_;
      @$zapline[3] =~ s_MHZ;
      @$zapline[4] =~ sFEC_;
      @$zapline[4] =~ s_\/;
      @$zapline[5] =~ sFEC_;
      @$zapline[5] =~ s_\/;
      @$zapline[6] =~ sQAM_qam_;
      @$zapline[7] =~ sTRANSMISSION_MODE_;
      @$zapline[7] =~ sK;
      @$zapline[8] =~ sGUARD_INTERVAL_;
      @$zapline[8] =~ s_\/;
      @$zapline[12] =~ s@\n@@;
      
      @$channel[3] =~ s@\n@@;
      @$channel[0] =~ s@\'@\\\'@;

      if (!($xmltvfile eq "") && !(@$channel[2] eq "NULL")){
        print XF  "channel @$channel[2] \n";
        }

      if (!($chanidentsfile eq "") && !(@$channel[2] eq "NULL")){
        print CF  "@$zapline[12] @$channel[2]\n";
        }

      if (!(@$channel[2] eq "NULL")){
          @$channel[2] = "\'@$channel[2]\'";
          }
      else {
          @$channel[2] = "\'\'";
          }

      if (!(@$channel[3] eq "NULL")){
          @$channel[3] = "\'@$channel[3]\'";
          }
      else {
          @$channel[3] = "\'none\'";
          }
      
      print "REPLACE INTO dvb_channel \(chanid, serviceid, ";
      print "networkid, providerid, transportid, frequency, inversion, ";
      print "symbolrate, fec, polarity, satid, modulation, bandwidth, ";
      print "lp_code_rate, transmission_mode, guard_interval, hierarchy, ";
      print "pmtcache\) VALUES \(@$channel[1], @$zapline[12], NULL,NULL,";
      print "NULL, @$zapline[1], \'a\', NULL, \'@$zapline[5]\', \'h\', 0,";
      print " \'@$zapline[6]\', \'@$zapline[3]\', \'@$zapline[4]\', ";
      print "\'@$zapline[7]\', \'@$zapline[8]\', \'n\', NULL\)\;\n";

      print "REPLACE INTO dvb_pids \(chanid, pid, type, lang\) ";
      print "VALUES \(@$channel[1], @$zapline[10], \'v\', \'\'\)\;\n";

      print "REPLACE INTO dvb_pids \(chanid, pid, type, lang\) ";
      print "VALUES \(@$channel[1], @$zapline[11], \'a\', \'\'\)\;\n";
      
      print "REPLACE INTO channel \(chanid, channum, freqid, ";
      print "sourceid, callsign, name, icon, finetune, videofilters, ";
      print "xmltvid, recpriority, contrast, brightness, colour, hue, ";
      print "tvformat, commfree, visible\) VALUES \(@$channel[1], ";
      print "\'@$channel[1]\', \'\', 1, \'@$channel[0]\', ";
      print "\'@$channel[0]\', @$channel[3], NULL, \'\', @$channel[2], ";
      print "0, 32768, 32768, 32768, 32768, \'Default\',\'0\', \'1\'\)\;\n";
      print "\n\n";
      }
    }



  }
if (!($xmltvfile eq "")){
  close (XF);
  }
if (!($chanidentsfile eq "")){
  close (CF);
  }
